/*******************************************************************************
* Este trabalho e todas as suas derivaes pertencem  Universidade Federal de *
* Santa Maria (UFSM).  vedado seu uso em aplicaes comerciais.  Esta    uma *
* ferramenta didtica e, como tal, pode conter falhas que acarretem  problemas *
* durante seu uso. A UFSM isenta-se de qualquer prejuzo causado pelo  uso  do *
* mesmo. Qualquer modificao e/ou derivao do mesmo deve ser remetida ao seu *
* autor original.                                                              *
*                                                                              *
* Autor: Antonio Marcos de Oliveira Candia                                     *
* Data: 03/09/2009                                                             *
*                                                                              *
*******************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>

#define ITERACOES	1000000000 /* ajustar este valor, se necessrio */

			
double diftempo(struct timeval i, struct timeval f){
  	double d;
	d = (f.tv_sec - i.tv_sec) * 1000000;
	if (d>0 || (f.tv_usec < i.tv_usec))
		d += (f.tv_usec+1000000) - i.tv_usec;
	else
		d += f.tv_usec - i.tv_usec;
	return d;
}

/* Um benchmark sintetico simples, com um nico loop */
int main(int argc, char **argv) {
	struct timeval inicio, fim;
	double dif;
	int i;
	struct timezone tz;

	/* loop com muitas iteracoes para conseguir */
	/* testar quaisquer instrucoes, mesmo as muito rpidas */
	
        gettimeofday(&inicio, &tz);

	for(i=0; i < ITERACOES; i++){
		/* seu cdigo AQUI */
	}

        gettimeofday(&fim, &tz);

	printf("inicio: %d:%d fim: %d:%d\n",(int)inicio.tv_sec, (int)inicio.tv_usec, (int)fim.tv_sec, (int)fim.tv_usec);
        dif = diftempo(inicio,fim);
	printf("%i iteraes.\n",i);
	printf("Tempo Total: %lf s.\n" ,dif/1000000);
	printf("Media: %lf it/seg\n",(double)ITERACOES/(dif/1000000));
	exit(0);
   }
   

